/**
 * @file		includes.h
 * @author 		Ola Mogstad (olamo@stud.ntnu.no)
 * @updated		23/03/08
 * @brief		Holds all extra libraries that must be included.
 */

#ifndef INCLUDES_H
#define INCLUDES_H

#define LINUX_ONLY

// From autoconf
#ifdef LINUX_ONLY
	#include "config.h"
#endif

// Standard libraries
#include <iostream>
#include <stdexcept>
#include <string>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <stdlib.h>
#include <cstdlib>
#include <queue>
#include <strings.h>
#include <stdio.h>
#include <errno.h>
#include <sys/types.h>
#include <unistd.h>
#include <stdint.h>
#include <fstream>

// GTK+ stuff
#ifdef LINUX_ONLY
	#include <gtkmm.h>
	#include <libglademm/xml.h>
#endif

// LIBCURL
#include <curl/curl.h>

// LIBSDL
#include <SDL/SDL.h>

#ifdef LINUX_ONLY
	#include <SDL/SDL_image.h>
	#include <SDL/SDL_ttf.h>
#endif

// LIBAV
extern "C"
{
	//#include "avcodec.h"
	//#include "avformat.h"
	
	#include <avcodec.h>
	#include <avformat.h>
	
#ifdef NEW_FFMPEG	
	#include "swscale.h"		// note: GPL
#endif
}

// Common proprietary libraries
#include "StopWatch.h"
#include "Sysinfo.h"
//#include "SFont.h"
#include "Logger.h"
Logger LOG;
#include "Netstuff.h"
#include "SuperBuffer.h"

// LIBGXSYS
#include "clientLGV.h"

#endif // INCLUDES_H
