/**
 ****************************************************************************
 *
 *  @file   pktcache.h
 *  @author Ole-Ivar Holthe
 *  @date   2007-02-27
 *  @brief  Defines the CGSPktCache class.
 *
 *  Copyright  Gridmedia Technologies 1996-2008. All Rights Reserved.
 *
 ****************************************************************************/

#ifndef GS_COMMON_PKTCACHE_H
#define GS_COMMON_PKTCACHE_H

#define MAXPKTS 40

class CGSPktCache
{
public:
    CGSPktCache();
    virtual ~CGSPktCache();
	
// Attributes
public:
    struct GXPKT
    {
        BYTE nType;
        LONGLONG nTimestamp;
        int nFlags;
        int nPktNum;
        int nPktCount;
	UINT nPktSeqNo;
        BYTE* pPktData;
        int nPktBytes;
    };

    int   m_i;
    GXPKT m_pkts[MAXPKTS];
    GXPKT m_ret;

// Analysis
public:
    UINT m_nPktSeqNoLastPut;
    UINT m_nPktCountPut;

// Methods
public:
    virtual void Clear();
    virtual BOOL Put(BYTE nType, LONGLONG nTimestamp, int nFlags, 
        int nPktNum, int nPktCount, UINT nPktSeqNo, BYTE* pData, int nBytes);
    virtual GXPKT* Get();
};


#endif // GS_COMMON_PKTCACHE_H

/*
 ***************************************************************************/
