/**
 ****************************************************************************
 *
 *  @file   sockudp.h
 *  @author Ole-Ivar Holthe
 *  @date   2007-02-22
 *  @brief  Defines the CGSSockUDP class.
 *
 *  Copyright  Gridmedia Technologies 1996-2008. All Rights Reserved.
 *
 ****************************************************************************/

#ifndef GS_COMMON_SOCKUDP_H
#define GS_COMMON_SOCKUDP_H


class CGSSockUDP
{
public:
    CGSSockUDP();
    virtual ~CGSSockUDP();

// Methods
public:
    virtual BOOL Create();
    virtual void Destroy();
    virtual BOOL Bind(LPCTSTR szIP, int nPort);

// Globals
public:
    static BOOL Resolve(struct sockaddr_in* saddr, LPCTSTR szAddress, int port);

// Win32
#ifdef _WIN32
    static BOOL SockLibInit(WSADATA* lpwsaData = NULL);
#endif
	
// Attributes
public:
    SOCKET m_sd;
    struct sockaddr_in m_addrBind;
};


// Macros
#define PRNIP(addr) \
    (unsigned char)addr.sin_addr.S_un.S_un_b.s_b1, \
    (unsigned char)addr.sin_addr.S_un.S_un_b.s_b2, \
    (unsigned char)addr.sin_addr.S_un.S_un_b.s_b3, \
    (unsigned char)addr.sin_addr.S_un.S_un_b.s_b4


#endif // GS_COMMON_SOCKUDP_H

/*
 ***************************************************************************/
