#ifndef STRUCTS_H
#define STRUCTS_H

// Definining the UserInfo struct
struct UserInfo {
	
	UserInfo()
		: fullscreen(0), grabinput(0), port(0), infoRetrieved(0), packetsize(0), framerate(0)
	{
		username = new char[USER_INPUT_SIZE];
		password = new char[USER_INPUT_SIZE];
		server = new char[USER_INPUT_SIZE];
		game = new char[USER_INPUT_SIZE];
		profile = new char[USER_INPUT_SIZE];
		size = new char[USER_INPUT_SIZE];
		abitrate = new char[USER_INPUT_SIZE];
	}
		
	string ToString()
	{
		
		char* tmp1 = new char[1024];
		sprintf(tmp1,"%s | %s | %s | %s | %i | %s | %s | %i | %i | %s",
				username, password, server, game, port, profile, size, packetsize, framerate, abitrate);
		
		string tmp2(tmp1);
		delete [] tmp1;
		return tmp2;
	}
	
	void Clear()
	{
		fullscreen = 0; grabinput = 0; port = 0; infoRetrieved = 0, packetsize = 0; framerate = 0;
		bzero(username, strlen(username));
		bzero(password, strlen(password));
		bzero(server, strlen(server));
		bzero(game, strlen(game));
		bzero(profile, strlen(profile));
		bzero(size, strlen(size));
		bzero(abitrate, strlen(abitrate));
	}
	
	char* username;
	char* password;
	char* server;
	char* game;
	char* profile;
	char* size;
	char* abitrate;
	int packetsize;
	int framerate;
	int fullscreen;
	int grabinput;
	int port;
	int infoRetrieved;
};

// Defining the SocketInfo struct used in client and input handler
struct SocketInfo
{
	// Address and socket
	struct sockaddr_in serverAddress;
	int socketDescriptor;
	int connectedToServer;
	
	// Statistics
	int packetsReceived;
	int bytesReceived;
};

// Defining the ServerInfo struct that is used for retrieved server data
struct ServerInfo
{
	ServerInfo()
		: id(-1), reserved(-1), status(-1), URL(new char[256]), description(new char[256])
		{}
	
	string ToString()
	{
		char* tmp1 = new char[1024]; 
		sprintf(tmp1,"id=%i reserved=%i status=%i URL=%s description=%s",
				id, reserved, status, URL, description);
		string tmp2(tmp1);
		delete [] tmp1;
		return tmp2;
	}
	
	int id;
	int reserved;	
	int status; 	// 0 = rdy, >0 = busy, -1 = offline
	char* URL;
	char* description;
};

// Defining the GameInfo struct
struct GameInfo
{
	GameInfo()
		: id(-1),shortname(new char[256]),platform(new char[256]),
		genre(new char[256]),releasedate(new char[256]),renderer(new char[256]),
		title(new char[256]),publisher(new char[256]),developer(new char[256]),
		reserved1(-1),reserved2(new char[256]),servers(new int[30])
		{}
	
	string ToString()
	{
		char* tmp1 = new char[1024];
		sprintf(tmp1,"id=%i shortname=%s title=%s genre=%s publisher=%s",
				id, shortname, title, genre, publisher);
		string tmp2(tmp1);
		delete [] tmp1;
		return tmp2;
	}
	
	int id;
	char* shortname;
	char* platform;
	char* genre;
	char* releasedate;
	char* renderer;
	char* title;
	char* publisher;
	char* developer;
	int reserved1;
	char* reserved2;
	int* servers;	
};

// Gathers some time statistics
struct Statistics
{
	StopWatch sw_total;
	StopWatch sw_decode;
	StopWatch sw_render;
} stats;

// Holds information about the stream
struct HUDStreamInfo
{
	int ParsePacket(const char* packet)
	{
		if ( strncmp(packet,"OK",2) != 0 ) return -1;
		
		int ret = sscanf(packet,"%*s\n%i\n%i\n%i\n%i\n%i\n%i\n%i\n%i\n%i\n%i\n%i\n%i\n%i\n",
				&packetsize,&video_codecid, &video_bitrate, &video_pix_fmt, &video_width,
				&video_height, &video_fps, &audio_codecid, &audio_bitrate, &audio_channels,
				&audio_samplerate, &audio_bitspersample, &inputflags	
		);
		
		if (ret != 13) return -1;
		
		return 0;
	}
	
	void Print()
	{
		printf("Packetsize:\t\t %i\n",packetsize);
		printf("\nVideo:\n");
		//printf("Codec ID:\t\t %i (%s)\n",video_codecid,GXLinuxDecoder::CharCodecID(*reinterpret_cast<CodecID*>(&video_codecid)));
		printf("Codec ID:\t\t %i\n",video_codecid);
		printf("Bitrate:\t\t %i\n",video_bitrate);
		//printf("PIX_FMT:\t\t %i (%s)\n",video_pix_fmt,GXLinuxDecoder::CharPixFmt(*reinterpret_cast<PixelFormat*>(&video_pix_fmt)));
		printf("PIX_FMT:\t\t %i\n",video_pix_fmt);
		printf("Width:\t\t\t %i\n",video_width);
		printf("Height:\t\t\t %i\n",video_height);
		printf("FPS:\t\t\t %i\n",video_fps);
		printf("\nAudio:\n");
		printf("Codec ID:\t\t %i\n",audio_codecid);
		printf("Bitrate:\t\t %i\n",audio_bitrate);
		printf("Channels:\t\t %i\n",audio_channels);
		printf("Samplerate:\t\t %i\n",audio_samplerate);
		printf("Bits per sample:\t %i\n",audio_bitspersample);
		printf("\nOther:\n");
		printf("Input flags:\t\t %i\n",inputflags);
	}
	
	// General
	int 		packetsize;
	
	// Video
	int			video_codecid;
	int			video_bitrate;
	int			video_pix_fmt;
	int 		video_width;
	int			video_height;
	int			video_fps;
	
	// Audio
	int			audio_codecid;
	int			audio_bitrate;
	int			audio_channels;
	int			audio_samplerate;
	int			audio_bitspersample;
	
	// Other..?
	int			inputflags;
};

#endif // STRUCTS_H
