#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int ParseLog(const char* filename)
{
	FILE* file;
	file = fopen(filename, "r");
	if (file == NULL)
	{
		printf("Failed to open file\n");
		return -1;
	}
	
	int sessions = 0, lines = 0;
	
	char* line = NULL;
	size_t len = 0;
	ssize_t read = 0;
	while ((read = getline(&line,&len,file)) != -1) 
	{
		//LOG:Roundtrip latency: 61ms   Packet loss: 492   Packets: 4596
		int latency, loss, packets;
		if ( (read > 50) && (strncmp(line,"LOG:Roundtrip latency:",22) == 0) )
		{
			sscanf(line,"%*s %*s %i%*s %*s %*s %i %*s %i",&latency,&loss,&packets);
			printf("%i;%i;%i;\n",latency,loss,packets);
			lines++;
		}
		else
		{
			if ( (read > 13) && (strncmp(line,"CONNECT VIDEO",13) == 0) )
				sessions++;
			printf("%s",line);
		}
	}
	
	printf("--- end ---\n");
	printf("Sessions: %i\n",sessions);
	printf("Lines: %i\n",lines);
	
	if (line)
		free(line);
	fclose(file);
			
	return 0;
}

int main(int argc, char* argv[])
{
	if ( (argc != 2) || (strlen(argv[1]) <= 0) )
	{
		printf("Syntax: ./logparser <filename>\n");
		return -1;
	}
	
	return ParseLog(argv[1]);	
}
